jQuery( function( $ ) {
	var wc_shipment_shipany_label_items = {
		// init Class
		init: function() {
			$( '#woocommerce-shipment-shipany-label' )
				.on( 'click', '#shipany-label-button', this.save_shipany_label );
			$( '#woocommerce-shipment-shipany-label' )
				.on( 'click', '#shipany-label-button-recreate', this.save_shipany_label_recreate );
			$( '#woocommerce-shipment-shipany-label' )
				.on( 'click', '#shipany-pickup-button', this.pickup_fn );
			$( '#woocommerce-shipment-shipany-label' )
				.on( 'click', 'a#shipany_delete_label', this.delete_shipany_label );
			$( '#woocommerce-shipment-shipany-label' )
				.on( 'change', '#pr_shipany_return_address_enabled', this.show_hide_return );
			wc_shipment_shipany_label_items.show_hide_return();

			$( '#woocommerce-shipment-shipany-label' )
				.on( 'change', '#pr_shipany_identcheck', this.show_hide_ident );
			wc_shipment_shipany_label_items.show_hide_ident();

			$( '#woocommerce-shipment-shipany-label' )
				.on( 'change', '#pr_shipany_routing', this.show_hide_routing);
			wc_shipment_shipany_label_items.show_hide_routing();

			$( '#woocommerce-shipment-shipany-label' )
				.on( 'change', '#pr_shipany_product', this.validate_product_return );
		
			$( '#woocommerce-shipment-shipany-label' )
				.on( 'change', 'select#pr_shipany_total_packages', this.process_package_action );

			$( '#woocommerce-shipment-shipany-label' )
				.on( 'change', '#pr_shipany_multi_packages_enabled', this.show_hide_packages );
			wc_shipment_shipany_label_items.show_hide_packages();
		},

		// Extract the entries for the given package attribute
		get_package_array: function($form, attrib) {
			var $element = $form.find('input[name="pr_shipany_packages_'+attrib+'[]"]');
			var result = [];

			if ('undefined' !== typeof $element && $element) {
				result = $element.map(function() {
					return $(this).val();
				}).get();
			}

			return result;
		},

		// Extract all user inputted packages. Retrieving all available
		// package info or attributes.
		get_packages_for_saving: function($form, required) {
			var total = $form.find('select#pr_shipany_total_packages').val();
			var packages = [],
				error = false,
				invalid_number = false;

			var numbers = this.get_package_array($form, 'number');
			var weights = this.get_package_array($form, 'weight');
			var lengths = this.get_package_array($form, 'length');
			var widths = this.get_package_array($form, 'width');
			var heights = this.get_package_array($form, 'height');

			for (var i=0; i<parseInt(total); i++) {
				if (required) {
					if (!numbers[i].length || !weights[i].length || !lengths[i].length || !widths[i].length || !heights[i].length) {
						error = true;
						break;
					} else {
						if (!$.isNumeric(weights[i]) || !$.isNumeric(lengths[i]) || !$.isNumeric(widths[i]) || !$.isNumeric(heights[i])) {
							invalid_number = true;
							break;
						}
					}
				}

				packages.push({
					number: numbers[i], weight: weights[i], length: lengths[i], width: widths[i], height: heights[i]
				});
			}

			if (invalid_number) {
				return 'invalid_number';
			}

			return (!error) ? packages : false;
		},

		// Process the cloning (adding) and removing of package entries based
		// on the total packages selected by the user.
		process_package_action: function() {
			var old_value = $(this).data('current');
			var value = $(this).val();
			var $container = $('.total_packages_container');

			if (parseInt(old_value) < parseInt(value)) {
				var new_value = parseInt(value) - parseInt(old_value);
				var $clone, $package_number, new_number;

				for (var i=0; i<new_value; i++) {
					$clone = $container.find('.package_item:last').clone();
					$package_number = parseInt($clone.find('.package_number > input').data('sequence'));
					new_number = parseInt($package_number)+1;

					// We'll update both the cache and DOM to make sure that we get
					// the expected behaviour when pulling the sequence number for processing.
					$clone.find('.package_number > input').attr('data-sequence', new_number); // this updates the DOM
					$clone.find('.package_number > input').data('sequence', new_number); // this updates the jquery cache

					$clone.find('.package_number > input').val(new_number);
					$clone.find('.package_item_field.clearable > input').val('');
				$container.append($clone);
				}
			} else {
				$container.find('.package_item').slice(value).remove();
			}
			
			$(this).data('current', value);
		},
	
		validate_product_return: function () {
			var selected_product = $( '#pr_shipany_product' ).val();

			if( selected_product != 'V01PAK' && selected_product != 'V01PRIO' ) {
				$('#pr_shipany_return_address_enabled').prop('checked', false).trigger('change');
				$('#pr_shipany_return_address_enabled').prop('disabled', 'disabled');
			} else {
				$('#pr_shipany_return_address_enabled').removeAttr('disabled');
			}

		},

		show_hide_return: function () {
			var is_checked = $( '#pr_shipany_return_address_enabled' ).prop('checked');

			$( '#shipment-shipany-label-form' ).children().each( function () {
				
				// If class exists, and is not 'pr_shipany_return_address_enabled' but is 'pr_shipany_return_' field
			    if( ( $(this).attr("class") ) &&
			    	( $(this).attr("class").indexOf('pr_shipany_return_address_enabled') == -1 ) &&
			    	( $(this).attr("class").indexOf('pr_shipany_return') >= 0 ) 
			    ) {
			    	
			    	if ( is_checked ) {
			    		$(this).show();
			    	} else {
			    		$(this).hide();
			    	}
			    }
			});
		},
	
		show_hide_ident: function () {
			var is_checked = $( '#pr_shipany_identcheck' ).prop('checked');

			$( '#shipment-shipany-label-form' ).children().each( function () {
				
				// If class exists, and is not 'pr_shipany_return_address_enabled' but is 'pr_shipany_return_' field
			    if( ( $(this).attr("class") ) &&
			    	( $(this).attr("class").indexOf('pr_shipany_identcheck_field ') == -1 ) &&
			    	( $(this).attr("class").indexOf('pr_shipany_identcheck') >= 0 ) 
			    ) {
			    	
			    	if ( is_checked ) {
			    		$(this).show();
			    	} else {
			    		$(this).hide();
			    	}
			    }
			});
		},

		show_hide_routing: function () {
			var is_checked = $( '#pr_shipany_routing' ).prop('checked');

			$( '#shipment-shipany-label-form' ).children().each( function () {

				// If class exists, and is not 'pr_shipany_return_address_enabled' but is 'pr_shipany_return_' field
			    if( ( $(this).attr("class") ) &&
			    	( $(this).attr("class").indexOf('pr_shipany_routing_field ') == -1 ) &&
			    	( $(this).attr("class").indexOf('pr_shipany_routing') >= 0 )
			    ) {

			    	if ( is_checked ) {
			    		$(this).show();
			    	} else {
			    		$(this).hide();
			    	}
			    }
			});
		},

		show_hide_packages: function () {
			// Only relevant for Paket so check if exists
			if ( ! $( '#pr_shipany_multi_packages_enabled' ).length ) {
			    return;
			}

			var is_checked = $( '#pr_shipany_multi_packages_enabled' ).prop('checked');

			if ( is_checked ) {
	    		$('#pr_shipany_weight').prop('disabled', 'disabled');
			} else {
				$('#pr_shipany_weight').removeAttr('disabled');
	    	}

			$( '#shipment-shipany-label-form' ).children().each( function () {
				// If class exists, and is not 'pr_shipany_multi_packages_enabled' but is 'pr_shipany_total_packages' or 'total_packages_container' fields
			    if( ( $(this).attr("class") ) &&
			    	( $(this).attr("class").indexOf('pr_shipany_multi_packages_enabled') == -1 ) &&
			    	( ( $(this).attr("class").indexOf('pr_shipany_total_packages') >= 0 ) || 
			    	( $(this).attr("class").indexOf('total_packages_container') >= 0 ) )			    	
			    ) {
			    	
			    	if ( is_checked ) {
			    		$(this).show();
			    	} else {
			    		$(this).hide();
			    	}
			    }
			});
		},

		pickup_fn: function (e) {
			document.getElementById('shipany-pickup-button').innerHTML='Loading...';
			document.getElementById('shipany-pickup-button').style.cursor = 'default';
			document.getElementById('shipany-pickup-button').style.pointerEvents = 'none';
			e.preventDefault();
			var data = {
				action:                   'wc_send_pick_up_request',
				order_id:                 woocommerce_admin_meta_boxes.post_id,
			};
			$.post( woocommerce_admin_meta_boxes.ajax_url, data, function( response ) {
				$(function(){ 
					$('#shipment-shipany-label-form').each(function(i, div) {
						$(div).find('button').each(function(j, element){
							$(element).prop('disabled','disabled');
						});
					});
					$( '#shipany-label-print').css('cursor', 'pointer');
					$( '#shipany-label-print').css( 'pointer-events', 'auto' );
					$( '#shipany-label-print').css('opacity', '1');
					$( '#shipany-label-print').removeAttr("disabled");
					// zeek2door update url 
					if (response.lab_url) {
						$( '#shipany-label-print').attr("href", response.lab_url );
					}
					
					
				});
				document.getElementById('shipany-pickup-button').innerHTML='Send Pickup Request';
				document.getElementById('order_status').innerHTML='Order Status: Pickup Request Received'
			});

		},


		save_shipany_label: function () {
					
			// loop through inputs within id 'shipment-shipany-label-form'
			var data = {
				action:                   'wc_shipment_shipany_gen_label',
				order_id:                 woocommerce_admin_meta_boxes.post_id,
			};
			
			// In case an error has occured.
			var abort = false;
			var $form = $('#shipment-shipany-label-form'); 
			$form.each(function(i, div) {

			    $(div).find('input').each(function(j, element){
			        if( $(element).attr('type') == 'checkbox' ) {
			        	if ( $(element).prop('checked') ) {
				        	data[ $(element).attr('name') ] = 'yes';
			        	} else {
				        	data[ $(element).attr('name') ] = 'no';
			        	}
			        } else {
			        	var eName = $(element).attr('name');
			        	// Do NOT add array inputs here!
			        	if (eName.indexOf("[]") == -1) {
			        		data[ $(element).attr('name') ] = $(element).val();
			        	}
			        }
			    });

			    $(div).find('select').each(function(j, element){
		        	data[ $(element).attr('name') ] = $(element).val();
			    });

			    $(div).find('textarea').each(function(j, element){
		        	data[ $(element).attr('name') ] = $(element).val();
			    });
	    	});
			if( $( '#pr_shipany_multi_packages_enabled' ).prop('checked') ) {

				var packages = wc_shipment_shipany_label_items.get_packages_for_saving($form, true);
				if (!packages) {
					alert('It appears that one or more of your packages contains empty information. Please make sure you fill the package number, weight, length, width and height of the package before submitting.');
					abort = true;
				} else {
					if (packages == 'invalid_number') {
						alert('One or more of your entries contains invalid values. Only numeric values are allowed in the package line items. Please kindly check your entries and try again.');
						abort = true;
					} else {
					
						if (packages.length) {
							data [ 'pr_shipany_packages_number' ] = wc_shipment_shipany_label_items.get_package_array($form, 'number');
							data [ 'pr_shipany_packages_weight' ] = wc_shipment_shipany_label_items.get_package_array($form, 'weight');
							data [ 'pr_shipany_packages_length' ]  = wc_shipment_shipany_label_items.get_package_array($form, 'length');
							data [ 'pr_shipany_packages_width' ]  = wc_shipment_shipany_label_items.get_package_array($form, 'width');
							data [ 'pr_shipany_packages_height' ]  = wc_shipment_shipany_label_items.get_package_array($form, 'height');
						}
					}		
				}
			}
			
			if (!abort) {
				// Remove any errors from last attempt to create label
				$( '#shipment-shipany-label-form .wc_shipany_error' ).remove();

				$( '#shipment-shipany-label-form' ).block( {
					message: null,
					overlayCSS: {
						background: '#fff',
						opacity: 0.6
					}
				} );
				$.post( woocommerce_admin_meta_boxes.ajax_url, data, function( response ) {
					$( '#shipment-shipany-label-form' ).unblock();
					if ( response.error ) {
						$( '#shipment-shipany-label-form' ).append('<p class="wc_shipany_error">' + response.error + '</p>');
					} else if (response.insufficient_balance) {
						$(function(){ 
							$('#shipment-shipany-label-form').each(function(i, div) {
								$(div).find('input').each(function(j, element){
									$(element).prop('disabled', 'disabled');
								});
								$(div).find('select').each(function(j, element){
									$(element).prop('disabled', 'disabled');
								});
								$(div).find('textarea').each(function(j, element){
									$(element).prop('disabled','disabled');
								});
							});
						});
						$( '#shipany-label-button').remove();
						$( '#shipment-shipany-label-form .wc_shipany_error' ).remove();
						$( '#shipment-shipany-label-form' ).append('<button id="shipany-label-button-recreate" class="button button-primary button-save-form tooltip" data-title="Since ShipAny account is out of credit, the order falls to draft state">Create ShipAny Order (From Draft)</button>');
						$( '#shipment-shipany-label-form' ).append("<div class='wc_shipany_no_credit_error' style='color: #AA0000'>Please top up account and create order again.</div>");
					} else {
						// Disable all form items
						$(function(){ 
							$('#shipment-shipany-label-form').each(function(i, div) {
							    $(div).find('input').each(function(j, element){
							       $(element).prop('disabled', 'disabled');
							    });
							    $(div).find('select').each(function(j, element){
							        $(element).prop('disabled', 'disabled');
							    });
							    $(div).find('textarea').each(function(j, element){
							        $(element).prop('disabled','disabled');
							    });
					    	});
					    });
						$( '#shipment-shipany-label-form .wc_shipany_no_credit_error' ).remove();
						$( '#shipment-shipany-label-form' ).prepend('<div id="order_status">Order Status: Order Created</div>')
						$( '#shipany-label-button').remove();
						$( '#shipment-shipany-label-form' ).append(shipany_label_data.print_button);
						$( '#shipment-shipany-label-form' ).append('<p>');
						$( '#shipment-shipany-label-form' ).append(shipany_label_data.pickup_request);
						$( '#shipany-label-print').attr("href", response.label_url ); // update new url

						// $( '#shipment-shipany-label-form' ).append(shipany_label_data.delete_label);
						if (response.get_file_size == 0) {
							$( '#shipany-label-print').css('cursor', 'default');
							$( '#shipany-label-print').css( 'pointer-events', 'none' );
							$( '#shipany-label-print').css('opacity', '0.5');
						}
						if (response.insufficient_balance) {
							document.getElementById('order_status').innerHTML='Order Status: Order Drafted'
							$( '#shipany-pickup-button').css('cursor', 'default');
							$( '#shipany-pickup-button').css( 'pointer-events', 'none' );
							$( '#shipany-pickup-button').css('opacity', '0.5');
							$( '#shipment-shipany-label-form' ).append("<div style='color: #AA0000'>Please top up account and create order again.</div>");
						}
						
						// if( response.tracking_note ) {

						// 	$( '#woocommerce-order-notes' ).block({
						// 		message: null,
						// 		overlayCSS: {
						// 			background: '#fff',
						// 			opacity: 0.6
						// 		}
						// 	});
							
						// 	var data = {
						// 		action:                   'woocommerce_add_order_note',
						// 		post_id:                  woocommerce_admin_meta_boxes.post_id,
						// 		note_type: 				  response.tracking_note_type,
						// 		note:					  response.tracking_note,
						// 		security:                 woocommerce_admin_meta_boxes.add_order_note_nonce
						// 	};

						// 	$.post( woocommerce_admin_meta_boxes.ajax_url, data, function( response_note ) {
						// 		// alert(response_note);
						// 		$( 'ul.order_notes' ).prepend( response_note );
						// 		$( '#woocommerce-order-notes' ).unblock();
						// 		$( '#add_order_note' ).val( '' );
						// 	});							
						// }

						$( document ).trigger( 'pr_shipany_saved_label' );
					}
					if( response.tracking_note ) {

						$( '#woocommerce-order-notes' ).block({
							message: null,
							overlayCSS: {
								background: '#fff',
								opacity: 0.6
							}
						});
						
						var data = {
							action:                   'woocommerce_add_order_note',
							post_id:                  woocommerce_admin_meta_boxes.post_id,
							note_type: 				  response.tracking_note_type,
							note:					  response.tracking_note,
							security:                 woocommerce_admin_meta_boxes.add_order_note_nonce
						};

						$.post( woocommerce_admin_meta_boxes.ajax_url, data, function( response_note ) {
							// alert(response_note);
							$( 'ul.order_notes' ).prepend( response_note );
							$( '#woocommerce-order-notes' ).unblock();
							$( '#add_order_note' ).val( '' );
						});							
					}
				});
			}

			return false;
		},

		save_shipany_label_recreate: function () {
					
			// loop through inputs within id 'shipment-shipany-label-form'
			var data = {
				action:                   'wc_shipment_shipany_gen_label_recreate',
				order_id:                 woocommerce_admin_meta_boxes.post_id,
				shipany_order_id:			shipany_label_data.label_tracking_info == undefined? '': shipany_label_data.label_tracking_info.shipment_id,
				mch_id:			shipany_label_data.mch_uid == undefined? '': shipany_label_data.mch_uid
			};
			
			// Remove any errors from last attempt to create label
			$( '#shipment-shipany-label-form .wc_shipany_no_credit_error' ).remove();

			$( '#shipment-shipany-label-form' ).block( {
				message: null,
				overlayCSS: {
					background: '#fff',
					opacity: 0.6
				}
			} );
			$.post( woocommerce_admin_meta_boxes.ajax_url, data, function( response ) {
				$( '#shipment-shipany-label-form' ).unblock();
				if ( response.error == 'error' ) {
					$(function(){ 
						$('#shipment-shipany-label-form').each(function(i, div) {
							$(div).find('input').each(function(j, element){
								$(element).prop('disabled', 'disabled');
							});
							$(div).find('select').each(function(j, element){
								$(element).prop('disabled', 'disabled');
							});
							$(div).find('textarea').each(function(j, element){
								$(element).prop('disabled','disabled');
							});
						});
					});
					// $( '#shipment-shipany-label-form' ).append('<p class="wc_shipany_error">' + response.error + '</p>');
					$( '#shipment-shipany-label-form .wc_shipany_error' ).remove();
					$( '#shipment-shipany-label-form' ).append("<div class='wc_shipany_no_credit_error' style='color: #AA0000'>Please top up account and create order again.</div>");
				} else {
					$( '#shipment-shipany-label-form .wc_shipany_error' ).remove();
					// Disable all form items
					$(function(){ 
						$('#shipment-shipany-label-form').each(function(i, div) {
							$(div).find('input').each(function(j, element){
								$(element).prop('disabled', 'disabled');
							});
							$(div).find('select').each(function(j, element){
								$(element).prop('disabled', 'disabled');
							});
							$(div).find('textarea').each(function(j, element){
								$(element).prop('disabled','disabled');
							});
						});
					});

					$( '#shipany-label-button-recreate').remove();
					$( '#shipment-shipany-label-form' ).append(shipany_label_data.print_button);
					$( '#shipment-shipany-label-form' ).append('<p>');
					$( '#shipment-shipany-label-form' ).append(shipany_label_data.pickup_request);
					$( '#shipany-label-print').attr("href", response.label_url ); // update new url
					$( '#shipany-label-print').css( 'pointer-events', 'auto' );
					$( '#shipany-label-print').removeAttr('disabled');
					document.getElementById('order_status').innerHTML='Order Status: Order Created'

					if (response.courier_id == '85cc2f44-8508-4b46-b49d-28b7b4c65da4') {
						$( '#shipany-label-print').css('cursor', 'default');
						$( '#shipany-label-print').css( 'pointer-events', 'none' );
						$( '#shipany-label-print').css('opacity', '0.5');
					}
					// $( '#shipment-shipany-label-form' ).append(shipany_label_data.delete_label);
					// if (response.get_file_size == 0) {
					// 	$( '#shipany-label-print').css('cursor', 'default');
					// 	$( '#shipany-label-print').css( 'pointer-events', 'none' );
					// 	$( '#shipany-label-print').css('opacity', '0.5');
					// }
					// if (response.insufficient_balance) {
					// 	$( '#shipany-pickup-button').css('cursor', 'default');
					// 	$( '#shipany-pickup-button').css( 'pointer-events', 'none' );
					// 	$( '#shipany-pickup-button').css('opacity', '0.5');
					// 	$( '#shipment-shipany-label-form' ).append("<div style='color: #AA0000'>Please top up account and create order again in ShipAny portal.</div>");
					// }
					
					if( response.tracking_note ) {

						$( '#woocommerce-order-notes' ).block({
							message: null,
							overlayCSS: {
								background: '#fff',
								opacity: 0.6
							}
						});
						
						var data = {
							action:                   'woocommerce_add_order_note',
							post_id:                  woocommerce_admin_meta_boxes.post_id,
							note_type: 				  response.tracking_note_type,
							note:					  response.tracking_note,
							security:                 woocommerce_admin_meta_boxes.add_order_note_nonce
						};

						$.post( woocommerce_admin_meta_boxes.ajax_url, data, function( response_note ) {
							// alert(response_note);
							$( 'ul.order_notes' ).prepend( response_note );
							$( '#woocommerce-order-notes' ).unblock();
							$( '#add_order_note' ).val( '' );
						});							
					}

					$( document ).trigger( 'pr_shipany_saved_label' );
				}
			});
			

			return false;
		},

		delete_shipany_label: function () {

			$( '#shipment-shipany-label-form .wc_shipany_error' ).remove();

			$( '#shipment-shipany-label-form' ).block( {
				message: null,
				overlayCSS: {
					background: '#fff',
					opacity: 0.6
				}
			} );
			
			var data = {
				action:                   'wc_shipment_shipany_delete_label',
				order_id:                 woocommerce_admin_meta_boxes.post_id,
				pr_shipany_label_nonce:       $( '#pr_shipany_label_nonce' ).val()
			};
			
			$.post( woocommerce_admin_meta_boxes.ajax_url, data, function( response ) {
				$( '#shipment-shipany-label-form' ).unblock();
				if ( response.error ) {
					$( '#shipment-shipany-label-form' ).append('<p class="wc_shipany_error">Error: ' + response.error + '</p>');
				} else {

					$( '#shipment-shipany-label-form .wc_shipany_delete' ).remove();
					// Enable all form items
					$(function(){ 
						$('#shipment-shipany-label-form').each(function(i, div) {

						    $(div).find('input').each(function(j, element){
						       $(element).removeAttr('disabled');
						    });

						    $(div).find('select').each(function(j, element){
						        $(element).removeAttr('disabled');
						    });

						    $(div).find('textarea').each(function(j, element){
						        $(element).removeAttr('disabled');
						    });

				    	});
				    });
					
					$( '#shipany-label-print').remove();
					$( '#shipment-shipany-label-form' ).append(shipany_label_data.main_button);

					if( response.shipany_tracking_num ) {
						var tracking_note;
						$('ul.order_notes li').each(function(i) {
						   tracking_note = $(this);
						   tracking_note_html = $(this).html()
						   if (tracking_note_html.indexOf(response.shipany_tracking_num) >= 0) {
							
								// var tracking_note = $( this ).closest( 'li.tracking_note' ); 
								$( tracking_note ).block({
									message: null,
									overlayCSS: {
										background: '#fff',
										opacity: 0.6
									}
								});

								var data_note = {
									action:   'woocommerce_delete_order_note',
									note_id:  $( tracking_note ).attr( 'rel' ),
									security: woocommerce_admin_meta_boxes.delete_order_note_nonce
								};

								$.post( woocommerce_admin_meta_boxes.ajax_url, data_note, function() {
									$( tracking_note ).remove();
								});
								
							   	return false;					   	
							}
						});
					}

					$( document ).trigger( 'pr_shipany_deleted_label' );
				}
			});

			return false;
		},
	};
	
	wc_shipment_shipany_label_items.init();

} );
